/********************************** (C) COPYRIGHT *******************************
 * File Name          : Main.c
 * Author             : WCH
 * Version            : V1.0
 * Date               : 2020/08/06
 * Description        : ʱ
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * SPDX-License-Identifier: Apache-2.0
 *******************************************************************************/

#include "CH57x_common.h"
/*********************************************************************
 * @fn      DebugInit
 *
 * @brief   Գʼ
 *
 * @return  none
 */
void DebugInit(void)
{
    GPIOA_SetBits(GPIO_Pin_9);
    GPIOA_ModeCfg(GPIO_Pin_8, GPIO_ModeIN_PU);
    GPIOA_ModeCfg(GPIO_Pin_9, GPIO_ModeOut_PP_5mA);
    UART1_DefInit();
}

typedef struct {
    uint32_t g;
    uint32_t r;
    uint32_t b;
}ws2812_in_spi_buffer_t;

//__attribute__((aligned(4)))
__attribute__((aligned(4))) ws2812_in_spi_buffer_t ws2812_buf[30];
uint32_t map_table[8] = {
    0x8e888888,
    0xe8888888,

    0x888e8888,
    0x88e88888,

    0x88888e88,
    0x8888e888,

    0x8888888e,
    0x888888e8,
};

void ws2812_set_rgb(ws2812_in_spi_buffer_t *buf,uint8_t r,uint8_t g,uint8_t b){

    buf->r = 0x88888888;
    for(uint8_t i=0;i<8;i++){
        if(r&0x1) {
            buf->r |= map_table[i];
        }
        r>>=1;
    }

    buf->g = 0x88888888;
    for(uint8_t i=0;i<8;i++){
        if(g&0x1) {
            buf->g |= map_table[i];
        }
        g>>=1;
    }

    buf->b = 0x88888888;
    for(uint8_t i=0;i<8;i++){
        if(b&0x1) {
            buf->b |= map_table[i];
        }
        b>>=1;
    }
}


void ws2812_test(char argc ,char *argv) {
    SPI0_MasterDMATrans((uint8_t *)ws2812_buf, 12*30);
}

//endof ws2812

//const uint16_t user_rx_buffer_length_mask = 1024-1;
//volatile uint16_t user_rx_buffer_write_index;
//volatile uint16_t user_rx_buffer_read_index;
//uint8_t uart_rx_buffer[1024];






void ws2812_off_all(void) {
    for(uint32_t i=0;i<30;i++) {
        ws2812_set_rgb(&ws2812_buf[i],0,0,0);

    }
    SPI0_MasterDMATrans((uint8_t *)ws2812_buf, 12*30);
}
/*********************************************************************
 * @fn      main
 *
 * @brief   
 *
 * @return  none
 */
int main()
{
    uint8_t i;
    SetSysClock(CLK_SOURCE_PLL_60MHz);

    /* ôڵ */
    DebugInit();
    PRINT("Start @ChipID=%02X\n", R8_CHIP_ID);
    GPIOA_ModeCfg(GPIO_Pin_12|GPIO_Pin_13|GPIO_Pin_14, GPIO_ModeOut_PP_5mA);
    SPI0_MasterDefInit( );
    SPI0_CLKCfg(15);

#if 1
    for(uint32_t i=0;i<30;i++) {
        ws2812_set_rgb(&ws2812_buf[i],0xff,0xff,0xff);
    }
    SPI0_MasterDMATrans((uint8_t *)ws2812_buf, 12*30);
    DelayMs(1000);


    for(uint32_t i=0;i<30;i++) {
        ws2812_set_rgb(&ws2812_buf[i],0xff,0,0);
    }
    SPI0_MasterDMATrans((uint8_t *)ws2812_buf, 12*30);
    DelayMs(1000);


    for(uint32_t i=0;i<30;i++) {
        ws2812_set_rgb(&ws2812_buf[i],0x00,0xff,0);
    }
    SPI0_MasterDMATrans((uint8_t *)ws2812_buf, 12*30);
    DelayMs(1000);


    for(uint32_t i=0;i<30;i++) {
        ws2812_set_rgb(&ws2812_buf[i],0x00,0,0xff);
    }
    SPI0_MasterDMATrans((uint8_t *)ws2812_buf, 12*30);



    for(uint32_t i=0;i<30;i++) {

        ws2812_off_all();
        DelayMs(10);
        ws2812_set_rgb(&ws2812_buf[i],0x00,0,0xff);
        SPI0_MasterDMATrans((uint8_t *)ws2812_buf, 12*30);
        DelayMs(50);

    }

        for(uint32_t i=0;i<30;i++) {

        ws2812_off_all();
                    DelayMs(1);
        ws2812_set_rgb(&ws2812_buf[i],0xff,0xff,0xff);
                SPI0_MasterDMATrans((uint8_t *)ws2812_buf, 12*30);
        DelayMs(10);

    }

    for(uint32_t i=0;i<30;i++) {

        ws2812_off_all();
                DelayMs(1);
        ws2812_set_rgb(&ws2812_buf[i],0xff,0,0x00);
            SPI0_MasterDMATrans((uint8_t *)ws2812_buf, 12*30);
        DelayMs(10);

    }

        for(uint32_t i=0;i<30;i++) {

        ws2812_off_all();
        DelayMs(1);
        ws2812_set_rgb(&ws2812_buf[i],0x00,0xff,0x00);
        SPI0_MasterDMATrans((uint8_t *)ws2812_buf, 12*30);
        DelayMs(1);

    }

            for(uint32_t i=0;i<30;i++) {

        ws2812_off_all();
                        DelayMs(1);
        ws2812_set_rgb(&ws2812_buf[i],0x00,0x00,0xff);
                    SPI0_MasterDMATrans((uint8_t *)ws2812_buf, 12*30);
        DelayMs(10);

    }



#endif
    ws2812_off_all();
    uint8_t r,g,b;
    r = 0;
    g = 0;
    b = 0;
    uint32_t cnt = 0;
    while(1) {
#if 0
        for(uint32_t i=0;i<30;i++) {

            ws2812_off_all();
            DelayMs(1);
            ws2812_set_rgb(&ws2812_buf[i],0xff,0,0x00);
            SPI0_MasterDMATrans((uint8_t *)ws2812_buf, 12*30);
            DelayMs(20);

        }



#endif
        cnt ++;
        for(uint32_t i=0;i<512;i++) {
            //ws2812_off_all();

            DelayMs(1);
            if(i&0x100) {
                r = 0;
                g = 0;
                b = 0;
                if(cnt & 1) {
                    r = 511-i;
                }
                if(cnt & 2) {
                    g = 511-i;
                }
                if(cnt & 4) {
                    b = 511-i;
                }
            }else{
                r = 0;
                g = 0;
                b = 0;
                if(cnt & 1) {
                    r = i;
                }
                if(cnt & 2) {
                    g = i;
                }
                if(cnt & 4) {
                    b = i;
                }
            }
            for(uint32_t j=0;j<30;j++) {
                ws2812_set_rgb(&ws2812_buf[j],r,g,b);
            }
            SPI0_MasterDMATrans((uint8_t *)ws2812_buf, 12*30);
            DelayMs(10);
        }
    }
}
